package de.hazewood.rylius.mlgj1.elements.chars;

import de.hazewood.rylius.mlgj1.Element;
import de.hazewood.rylius.mlgj1.Game;
import de.hazewood.rylius.mlgj1.elements.props.Apple;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.geom.Vector2f;

import java.util.List;

public class RainbowDash extends Element/* of Loyalty*/ {

    private boolean leaving;
    private List<Element> elements;

    public RainbowDash(List<Element> elements) {
        super(Game.image("ponies/rd_1"));
        this.elements = elements;
        leaving = false;
    }

    @Override
    public void update(GameContainer gc, int delta) {
        super.update(gc, delta);

        for (Element el : elements) {
            if (el instanceof Apple) {
                Vector2f vec = el.origin();
                vec.add(((Apple) el).getOffset());
                if (vec.distance(origin()) <= 64) {
                    ((Apple) el).explode();
                    vel.add(el.getVel().scale(0.05f));
                }
            }
        }

        if (clicked(gc.getInput())) {
            level.addEvent("rainbow_dash", this, null);
        }
    }

    @Override
    public boolean combine(Element other) {
        return false;
    }
}
