package de.hazewood.rylius.mlgj1.elements.chars;

import de.hazewood.rylius.mlgj1.Element;
import de.hazewood.rylius.mlgj1.Game;
import de.hazewood.rylius.mlgj1.elements.props.Tom;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Vector2f;

public class Rarity extends Element {

    private Tom tom;
    private boolean leaving;

    public Rarity() {
        super(Game.image("ponies/rarity_1"));
        leaving = false;
    }

    @Override
    public void update(GameContainer gc, int delta) {
        super.update(gc, delta);

        if (clicked(gc.getInput())) {
            level.addEvent("rarity", this, null);
        }

        if (tom != null) {
            tom.getPos().set(getPos());
            tom.getPos().add(new Vector2f(-32, -128));
        }
    }

    @Override
    public void draw(GameContainer gc, Graphics g) {
        if (leaving) {
            image.draw(pos.getX() + image.getWidth(), pos.getY(), -image.getWidth(), image.getHeight());
        } else {
            image.draw(pos.getX(), pos.getY());
        }
        if (tom != null) {
            tom.draw(gc, g);
        }
    }

    public void leave() {
        leaving = true;
        vel.set(6, 0);
    }

    public void setTom(Tom tom) {
        this.tom = tom;
        if (tom != null) {
            leaving = true;
            vel.set(2, 0);
        }
    }

    @Override
    public boolean combine(Element other) {
        return false;
    }

    public Tom getTom() {
        return tom;
    }
}
