package de.hazewood.rylius.mlgj1.elements.props;

import de.hazewood.rylius.mlgj1.Element;
import de.hazewood.rylius.mlgj1.Game;
import de.hazewood.rylius.mlgj1.elements.chars.Discord;
import de.hazewood.rylius.mlgj1.particles.Emitter;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Vector2f;

public class CottonCandyCloud extends Element {

    private Emitter rain;
    private int ground;

    public CottonCandyCloud() {
        super(Game.image("props/cotton_candy_cloud"), true);
        ground = 300;
    }

    @Override
    public void update(GameContainer gc, int delta) {
        super.update(gc, delta);

        if (clicked(gc.getInput())) {
            level.addEvent("cloud", this, null);
            if (rain != null) {
                rain.stop();
            } else {
                rain = new Emitter(Game.image("particles/drop"), 140, 0, new Vector2f(80, 20), new Vector2f(0, 7.5f), new Vector2f());
                rain.setGround(ground);
            }
            level.pick(this);
        }

        if (rain != null) {
            rain.getPos().set(origin());
            rain.update(gc, delta);
            if (rain.isRemoveable()) {
                rain = null;
            }
        }
    }

    @Override
    public void draw(GameContainer gc, Graphics g) {
        if (rain != null) {
            rain.draw(gc, g);
        }

        super.draw(gc, g);
    }

    public void explode() {
        if (rain != null) {
            rain.stop();
            level.add(rain);
        }

        Emitter clouds = new Emitter(Game.image("particles/cloud"), 80, -1, new Vector2f(100, 30), new Vector2f(0, 0), new Vector2f(0, -0.5f));
        clouds.getPos().set(origin());
        level.add(clouds);

        removeable = true;
    }

    @Override
    public boolean combine(Element other) {
        if (other instanceof Discord) {
            this.explode();
        }
        return false;
    }

    public void setGround(int y) {
        ground = y;
    }
}
