package de.hazewood.rylius.mlgj1.levels;

import de.hazewood.rylius.mlgj1.Game;
import de.hazewood.rylius.mlgj1.MLGJ1;
import de.hazewood.rylius.mlgj1.Pony;
import de.hazewood.rylius.mlgj1.elements.MazeLocation;
import de.hazewood.rylius.mlgj1.elements.chars.Discord;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;

public class Maze extends Level {

    private static Image title;

    static {
        title = Game.image("title");
    }

    public Maze(MLGJ1 main) {
        super(main, Game.image("backdrops/maze"), -1);

        //MazeLocation twilight = new MazeLocation(Pony.TWILIGHT_SPARKLE);
        //add(twilight);

        //        if (main.getState().get("maze_pp") == -1) {
        //            MazeLocation pinkie = new MazeLocation(Pony.PINKIE_PIE);
        //            pinkie.getPos().set(700, 130);
        //            add(pinkie);
        //        }

        if (main.getState().get("maze_rd") == -1) {
            MazeLocation rainbow = new MazeLocation(Pony.RAINBOW_DASH);
            rainbow.getPos().set(690, 370);
            add(rainbow);
        }

        //        if (main.getState().get("maze_fs") == -1) {
        //            MazeLocation fluttershy = new MazeLocation(Pony.FLUTTERSHY);
        //            fluttershy.getPos().set(290, 490);
        //            add(fluttershy);
        //        }

        if (main.getState().get("maze_rarity") == -1) {
            MazeLocation rarity = new MazeLocation(Pony.RARITY);
            rarity.getPos().set(120, 340);
            add(rarity);
        }

        if (main.getState().get("maze_aj") == -1) {
            MazeLocation aj = new MazeLocation(Pony.APPLEJACK);
            aj.getPos().set(325, 360);
            add(aj);
        }

        Discord discord = new Discord();
        discord.getPos().set(600, 460);
        add(discord);

        int levels = main.getState().get("maze_rarity") + main.getState().get("maze_rd") + main.getState().get("maze_aj");
        if (levels == 3) {
            title = Game.image("win");
        } else if (main.getState().get("maze_rarity") == 0 || main.getState().get("maze_rd") == 0 || main.getState().get("maze_aj") == 0) {
            title = Game.image("loss");
        }
    }

    @Override
    protected void onEvent(Level.Event ev) {
        pickupSound.play();

        if (ev.getName().equals("location")) {
            Pony pony = (Pony) ev.getParams()[0];
            if (pony == Pony.APPLEJACK) {
                main.loadLevel(new MazeApplejack(main));
            } else if (pony == Pony.RARITY) {
                main.loadLevel(new MazeRarity((main)));
            } else if (pony == Pony.RAINBOW_DASH) {
                main.loadLevel(new MazeRainbowDash(main));
            }
        }
    }

    @Override
    public void updateInternal(GameContainer gc, int delta) {
        if (title != null && gc.getInput().isMousePressed(Input.MOUSE_LEFT_BUTTON)) {
            title = null;
        } else if (gc.getInput().isKeyPressed(Input.KEY_ESCAPE)) {
            main.reset();
            main.loadLevel(new Maze(main));
        }
    }

    @Override
    public void drawInternal(GameContainer gc, Graphics g) {
        if (title != null) {
            title.draw();
        } else {
            g.drawString("Press Escape to restart the game", 9, 9);
        }
    }

}
