package de.hazewood.rylius.mlgj1.levels;

import de.hazewood.rylius.mlgj1.Game;
import de.hazewood.rylius.mlgj1.MLGJ1;
import de.hazewood.rylius.mlgj1.elements.chars.Discord;
import de.hazewood.rylius.mlgj1.elements.chars.Rarity;
import de.hazewood.rylius.mlgj1.elements.props.CottonCandyCloud;
import de.hazewood.rylius.mlgj1.elements.props.Tom;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;

public class MazeRarity extends Level {

    private Rarity rarity;
    private Tom tom;

    public MazeRarity(MLGJ1 main) {
        super(main, Game.image("backdrops/rarity_1"), 15000);

        CottonCandyCloud cloud = new CottonCandyCloud();
        cloud.getPos().set(16, 16);
        cloud.setGround(440);
        add(cloud);

        discord = new Discord();
        discord.getPos().set(72, 88);
        add(discord);

        rarity = new Rarity();
        rarity.getPos().set(570, 288);
        add(rarity);

        tom = new Tom();
        tom.getPos().set(64, 200);
        add(tom);
    }

    @Override
    protected void onEvent(Event ev) {
        pickupSound.play();

        if (selected != null && ev.getSource() != selected) {
            if (selected.combine(ev.getSource())) {
                if (selected == tom && ev.getSource() == rarity) {
                    finished = true;
                }
                return;
            }
        }

        if (ev.getSource().isPickable()) {
            pick(ev.getSource());
        }
    }

    @Override
    protected void updateInternal(GameContainer gc, int delta) {
        if (!finished && remainingTime() <= 0) {
            rarity.leave();
            finished = true;
        } else if (rarity.getPos().getX() > 1000) {
            if (rarity.getTom() == null) {
                main.getState().put("maze_rarity", 0);
            } else {
                main.getState().put("maze_rarity", 1);
            }
            main.loadLevel(new Maze(main));
        }
    }

    @Override
    protected void drawInternal(GameContainer gc, Graphics g) {
        drawRemainingTime(g);

        if (finished) {
            if (rarity.getTom() == null) {
                loss.draw();
            } else {
                win.draw();
            }
        }
    }
}
